<?php
/**
* @version		$Id: emailcloak.php 10381 2008-06-01 03:35:53Z pasamio $
* @package		oomla
* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent('onPrepareContent', 'plgContentMNPTooltips');

/**
 * Plugin that cloaks all emails in content from spambots via Javascript.
 *
 * @param object|string An object with a "text" property or the string to be
 * cloaked.
 * @param array Additional parameters. See {@see plgEmailCloak()}.
 * @param int Optional page number. Unused. Defaults to zero.
 * @return boolean True on success.
 */
function plgContentMNPTooltips(&$row, &$params, $page=0)
{
	if (is_object($row)) {
		return plgMNPTooltips($row->text, $params);
	}
	return plgMNPTooltips($row, $params);
}

/**
 * Genarate a search pattern based on link and text.
 *
 * @param string The target of an e-mail link.
 * @param string The text enclosed by the link.
 * @return string A regular expression that matches a link containing the
 * parameters.
 */

/**
 * Cloak all emails in text from spambots via Javascript.
 *
 * @param string The string to be cloaked.
 * @param array Additional parameters. Parameter "mode" (integer, default 1)
 * replaces addresses with "mailto:" links if nonzero.
 * @return boolean True on success.
 */
 
function return_bool($val) {
		
		if ($val == 0) {
			return 'false';
		} else {
			return 'true';
		}
		
}

function return_titlealign($val) {
		
		if ($val == 0) {
			return 'left';
		} else {
			return 'right';
		}
		
}

function return_textalign($val) {
		
		if ($val == 0) {
			return 'left';
		} elseif($val == 1) {
			return 'right';
		} elseif($val == 2) {
			return 'justify';
		}
		
}
 
function plgMNPTooltips(&$text, &$params)
{

	$plugin = & JPluginHelper::getPlugin('content', 'mnp_tooltips');

	// Load plugin params info
	$pluginParams = new JParameter($plugin->params);
	
	//params
	$span_style = 'class="mnp_tooltips"';
	$sheet = '';
	if ($pluginParams->get('SpanCSS',1) == 1) {
		$SpanBg = $pluginParams->get('SpanBg','#eeeeee');
		$SpanhBg = $pluginParams->get('SpanhBg','#eeeeee');
		$SpanPadding = $pluginParams->get('SpanPadding','0px');
		$SpanhPadding = $pluginParams->get('SpanhPadding','0px');
		$SpanMargin = $pluginParams->get('SpanMargin','0px');
		$SpanhMargin = $pluginParams->get('SpanhMargin','0px');
		$SpanBorder = $pluginParams->get('SpanBorder','1px solid #cccccc');
		$SpanhBorder = $pluginParams->get('SpanhBorder','1px solid #bbbbbb');
		$SpanText = $pluginParams->get('SpanText','');
		$SpanhText = $pluginParams->get('SpanhText','');
		$sheet = '
		<style type="text/css"> 
			
			span.mnp_tooltips {
			background-color:'.$SpanBg.';
			padding: '.$SpanPadding.';
			margin: '.$SpanMargin.';
			border: '.$SpanBorder.';
			text : '.$SpanText.';
			}
			
			span.mnp_tooltips:hover {
			background-color:'.$SpanhBg.';
			padding: '.$SpanhPadding.';
			margin: '.$SpanhMargin.';
			border: '.$SpanhBorder.';
			text : '.$SpanhText.';
			}
			
		</style>';
	}
	
	$tt_Debug			= return_bool($pluginParams->get('tt_Debug',1));
	$tt_Enabled			= return_bool($pluginParams->get('tt_Enabled',1));
	$TagsToTip			= return_bool($pluginParams->get('TagsToTip',1));
	$Above				= return_bool($pluginParams->get('Above',0));
	$BgColor			= $pluginParams->get('BgColor','#E2E7FF');
	$BgImg				= $pluginParams->get('BgImg','');
	$BorderColor		= $pluginParams->get('BorderColor','#003099');
	$BorderStyle		= $pluginParams->get('BorderStyle','solid');	
	$BorderWidth		= $pluginParams->get('BorderWidth',1);
	$CenterMouse		= return_bool($pluginParams->get('CenterMouse',0));		
	$ClickClose			= return_bool($pluginParams->get('ClickClose',0));		
	$ClickSticky		= return_bool($pluginParams->get('ClickSticky',0));		
	$CloseBtn			= return_bool($pluginParams->get('CloseBtn',0));		
	$CloseBtnColors	= "['".$pluginParams->get('CloseBtnColors_BG')."', '".$pluginParams->get('CloseBtnColors_text')."', '".$pluginParams->get('CloseBtnColors_hBG')."', '".$pluginParams->get('CloseBtnColors_htext')."']";	
	$CloseBtnText		= $pluginParams->get('CloseBtnText','&nbsp;X&nbsp;');	
	$CopyContent		= return_bool($pluginParams->get('CopyContent',1));		
	$Delay				= $pluginParams->get('Delay',400);
	$Duration			= $pluginParams->get('Duration',0);			
	$Exclusive			= return_bool($pluginParams->get('Exclusive',0));		
	$FadeIn				= $pluginParams->get('FadeIn',100);			
	$FadeOut			= $pluginParams->get('FadeOut',100);
	$FadeInterval		= $pluginParams->get('FadeInterval',30);		
	$Fix				= $pluginParams->get('Fix','null');		
	$FollowMouse		= return_bool($pluginParams->get('FollowMouse',1));		
	$FontColor			= $pluginParams->get('FontColor','#000044');
	$FontFace			= $pluginParams->get('FontFace','Verdana,Geneva,sans-serif');
	$FontSize			= $pluginParams->get('FontSize','8pt');		
	$FontWeight			= $pluginParams->get('FontWeight','normal');			
	$Height				= $pluginParams->get('Height',0);			
	$JumpHorz			= return_bool($pluginParams->get('JumpHorz',0));	
	$JumpVert			= return_bool($pluginParams->get('JumpVert',1));	
	$Left				= return_bool($pluginParams->get('Left',0));		
	$OffsetX			= $pluginParams->get('OffsetX',14);		
	$OffsetY			= $pluginParams->get('OffsetY',8);		
	$Opacity			= $pluginParams->get('Opacity',100);		
	$Padding			= $pluginParams->get('Padding',3);			
	$Shadow				= return_bool($pluginParams->get('Shadow',0));	
	$ShadowColor		= $pluginParams->get('ShadowColor','#C0C0C0');
	$ShadowWidth		= $pluginParams->get('ShadowWidth',5);
	$Sticky				= return_bool($pluginParams->get('Sticky',0));	
	$TextAlign			= return_textalign($pluginParams->get('TextAlign',0));	
	$Title				= $pluginParams->get('Title','');		
	$TitleAlign			= return_titlealign($pluginParams->get('TitleAlign',0));	
	$TitleBgColor		= $pluginParams->get('TitleBgColor','');		
	$TitleFontColor		= $pluginParams->get('TitleFontColor','#FFFFFF');	
	$TitleFontFace		= $pluginParams->get('TitleFontFace','');		
	$TitleFontSize		= $pluginParams->get('TitleFontSize','');		
	$TitlePadding		= $pluginParams->get('TitlePadding',2);
	$Width				= $pluginParams->get('Width',0);	
	
	$style_script = '
	<script type="text/javascript">
	<!--
		var config = new Object();

		var tt_Debug	= '.$tt_Debug.'
		var tt_Enabled	= '.$tt_Enabled.'		
		var TagsToTip	= '.$TagsToTip.'		
		
		config. Above			= '.$Above.'
		config. BgColor			= "'.$BgColor.'"	
		config. BgImg			= "'.$BgImg.'"		
		config. BorderColor		= "'.$BorderColor.'"
		config. BorderStyle		= "'.$BorderStyle.'"
		config. BorderWidth		= '.$BorderWidth.'
		config. CenterMouse		= '.$CenterMouse.'	
		config. ClickClose		= '.$ClickClose.'	
		config. ClickSticky		= '.$ClickSticky.'
		config. CloseBtn		= '.$CloseBtn.'
		config. CloseBtnColors	= '.$CloseBtnColors.'
		config. CloseBtnText	= "'.$CloseBtnText.'"
		config. CopyContent		= '.$CopyContent.'
		config. Delay			= '.$Delay.'
		config. Duration		= '.$Duration.'
		config. Exclusive		= '.$Exclusive.'
		config. FadeIn			= '.$FadeIn.'
		config. FadeOut			= '.$FadeOut.'
		config. FadeInterval	= '.$FadeInterval.'
		config. Fix				= '.$Fix.'
		config. FollowMouse		= '.$FollowMouse.'
		config. FontColor		= "'.$FontColor.'"
		config. FontFace		= "'.$FontFace.'"
		config. FontSize		= "'.$FontSize.'"
		config. FontWeight		= "'.$FontWeight.'"
		config. Height			= '.$Height.'
		config. JumpHorz		= '.$JumpHorz.'
		config. JumpVert		= '.$JumpVert.'
		config. Left			= '.$Left.'
		config. OffsetX			= '.$OffsetX.'
		config. OffsetY			= '.$OffsetY.'
		config. Opacity			= '.$Opacity.'
		config. Padding			= '.$Padding.'
		config. Shadow			= '.$Shadow.'
		config. ShadowColor		= "'.$ShadowColor.'"
		config. ShadowWidth		= '.$ShadowWidth.'
		config. Sticky			= '.$Sticky.'
		config. TextAlign		= "'.$TextAlign.'"
		config. Title			= "'.$Title.'"
		config. TitleAlign		= "'.$TitleAlign.'"
		config. TitleBgColor	= "'.$TitleBgColor.'"
		config. TitleFontColor	= "'.$TitleFontColor.'"
		config. TitleFontFace	= "'.$TitleFontFace.'"
		config. TitleFontSize	= "'.$TitleFontSize.'"
		config. TitlePadding	= '.$TitlePadding.'
		config. Width			= '.$Width.'
	//-->
	</script>
	';
	
	//preg_match stuff
	//(,?\[?(.*)\]?)
	$pattern = '/\{mnp_tooltip="(.*)"(,\[(.*)\])?\}(.*)\{\/mnp_tooltip\}/U';
	$pattern_replace_start = '/\{mnp_tooltip="(.*)"\}/U';
	$pattern_replace_end = '/{\/mnp_tooltip\}/';
	
	if (preg_match_all($pattern, $text, $table, PREG_OFFSET_CAPTURE)) {
	
		for ($i=0;$i<=count($table[0])-1;$i++) {
		
			$_to_replace = '';
			if ($table[3][$i][0] and $table[3][$i][0] != '') {
				$_to_replace = '{mnp_tooltip="'.$table[1][$i][0].'",['.$table[3][$i][0].']}'.$table[4][$i][0].'{/mnp_tooltip}';
			} else {
				$_to_replace = '{mnp_tooltip="'.$table[1][$i][0].'"}'.$table[4][$i][0].'{/mnp_tooltip}';
			}
			//$_pos_in_text = strpos($text, $_to_replace);
			//$_pos_end = $_pos_in_text + strlen($_to_replace);
			
			//$text_before_replacement = substr($text, 0, $_pos_in_text-1);
			//$text_after_replacement = substr($text, $_pos_end);
			
			if ($table[3][$i][0] and $table[3][$i][0] != '') {
			$text_firstreplacement = str_replace($_to_replace, $sheet.$style_script.'<script type="text/javascript" src="'.$mosConfig_absolute_path.'plugins/content/MNP_Tooltips/wz_tooltip.js"></script><span onmouseover="Tip(\''.$table[1][$i][0].'\','.$table[3][$i][0].')" onmouseout="UnTip()" '.$span_style.' />'.$table[4][$i][0].'</span>', $text);
			$text_replacement = str_replace($_to_replace, '<span onmouseover="Tip(\''.$table[1][$i][0].'\','.$table[3][$i][0].')" onmouseout="UnTip()" '.$span_style.' />'.$table[4][$i][0].'</span>', $text);
			} else {
			$text_firstreplacement = str_replace($_to_replace, $sheet.$style_script.'<script type="text/javascript" src="'.$mosConfig_absolute_path.'plugins/content/MNP_Tooltips/wz_tooltip.js"></script><span onmouseover="Tip(\''.$table[1][$i][0].'\')" onmouseout="UnTip()" '.$span_style.' />'.$table[4][$i][0].'</span>', $text);
			$text_replacement = str_replace($_to_replace, '<span onmouseover="Tip(\''.$table[1][$i][0].'\')" onmouseout="UnTip()" '.$span_style.' />'.$table[4][$i][0].'</span>', $text);
			}
			
			if ($i == 0) {
				$text = $text_firstreplacement;
			} else {
				$text = $text_replacement;
			}
			
		}
	
		return true;
	}

	return true;
}
